## ----------------------------------------------------------------------------
# rishu_remote.pl
#   里珠・外部のプロセス側.
# -----------------------------------------------------------------------------
# Rishu::Remote->new()->run() を呼ぶと, あとは run の中から適宜
# main::on_load, etc.. が呼ばれます.
# 
# -----------------------------------------------------------------------------
# Mastering programed by YAMASHINA Hio
#
# Copyright 2002 YMIRLINK,Inc.
# -----------------------------------------------------------------------------
# $Id: rishu_remote.pl,v 1.9 2002/11/19 15:32:20 hio Exp $
# -----------------------------------------------------------------------------
package main;
use strict;

# -----------------------------------------------------------------------------
# 里珠つかう人の初期化

# このあたりにわきゃわきゃと.

# この辺まで.
# -----------------------------------------------------------------------------

BEGIN
{
  open OUT,">out.txt";
  select((select(OUT),$|=1)[0]);
  my $time = scalar(localtime);
  print OUT "$time> startup\n";
  $SIG{__DIE__} = sub{ print OUT scalar(localtime),"> $_[0]"};
}
eval { die "die test"; };

# -----------------------------------------------------------------------------
# Rishu::Remote 初期化.

#   lib/ ディレクトリを @INC に追加.
BEGIN
{
  my $here = $0;
  if( $^O eq 'MSWin32' )
  {
    $here =~ s/[^\\]+$//;
    $here ||= '.\\';
  }else
  {
    $here =~ s,[^/]+$,,;
    $here ||= './';
  }
  unshift @INC,$here.'lib';
}

# instance の構築.
BEGIN{print OUT "use Rushu::Remote..\n";}
use Rishu::Remote;
BEGIN{print OUT "  done.\n";}
Rishu::Remote->instance(@ARGV);

# 里珠の初期化, ここまで.
# -----------------------------------------------------------------------------

# -----------------------------------------------------------------------------
# Rishu::Remote 起動.
#   run() でブロックします.

eval { die "start run."; };
Rishu::Remote->instance()->run();

# -----------------------------------------------------------------------------
# 以下, 里珠ハンドラ

# -----------------------------------------------------------------------------
# on_load
sub on_load
{
  my $data = shift;
  $data;
}

# -----------------------------------------------------------------------------
# on_request
sub on_request
{
  my $data = shift;
  if( $data =~ /^thread/i )
  {
    thread_test($data);
  }elsif( $data =~ /^fork/i )
  {
    fork_test($data);
  }elsif( $data =~ /^exit/i )
  {
    exit_test($data);
  }else
  {
    "SHIORI/3.0 200 ok\r\n".
    "Message: enter 'thread', 'fork', or 'exit', and empty line.\r\n".
    "Repeat-of-Request: ".$data;
  }
}
sub thread_test
{
}

sub fork_test
{
  my $data = shift;
  my $pid = fork();
  if( !defined($pid) )
  {
    "SHIORI/3.0 500 Fork failed\r\n".
    "Error-Message: $!\r\n".
    "Repeat-of-Request: ".$data;
  }elsif( $pid )
  { # 親プロセス
    my $pid_got = waitpid(-1,0);
    "SHIORI/3.0 200 Fork ok\r\n".
    "Child-Pid: $pid_got\r\n".
    "Repeat-of-Request: ".$data;
  }else
  { # 子プロセス.
    sleep(1);
    exit(0);
  }
}
sub exit_test
{
  my $data = shift;
  Rishu::Remote->instance()->log('trace',"exit\n");
  #select Rishu::Proxy::LOG;
  #print Rishu::Proxy::LOG "Rishu::Proxy::LOG selected.\n";
  #$|=1;
  #print "go exit...\n";
  $SIG{__DIE__} = sub{Rishu::Remote->instance()->log('trace',"exit faled : $@")};
  exit 0;
}

# -----------------------------------------------------------------------------
# on_unload
sub on_unload
{
  1;
}

1;
